#ifndef		_MENU_DEF_H_
#define		_MENU_DEF_H_

#include <X11/Intrinsic.h>

typedef struct _menu_item {
	char*				label;		  	/* the label for the item */
	WidgetClass*		class;		  	/* pushbutton, label, separator... */
	char				mnemonic;	   	/* mnemonic; NULL if none */
	char*				accelerator;  	/* accelerator; NULL if none */
	char*				accel_text;	  	/* to be converted to compound string */
	void				(*callback)(); 	/* routine to call; NULL if none */
	XtPointer			callback_data; 	/* client_data for callback() */
	struct _menu_item*	subitems;	  	/* pullright menu items, if not NULL */
} MenuItem;

#define			DISPLAY(_a_, ...)		fprintf(stderr,"%s::%s [%05d] " _a_ "\n", __FILE__, __FUNCTION__, __LINE__, __VA_ARGS__)

Widget BuildPulldownMenu (Widget parent, char* menu_title, char menu_mnemonic, Boolean tear_off, MenuItem* items);
void UnmapWindow( );
void MapWindow( );

#endif
