#include <Xm/RowColumnP.h>
#include <Xm/RowColumn.h>
#include <Xm/MainW.h>
#include <Xm/DrawingA.h>
#include <Xm/CascadeBG.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleB.h>
#include <Xm/ToggleBG.h>

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "menu_def.h"

#include "menu_line.h"
#include "menu_circle.h"
#include "menu_angle.h"
#include "menu_restart.h"
#include "menu_exit.h"

Widget		   	toplevel, main_w, menubar, drawing_a;
XtAppContext   	app;

Widget BuildPulldownMenu (Widget parent, char* menu_title, char menu_mnemonic, Boolean tear_off, MenuItem* items)
{
	Widget		 PullDown, cascade, widget;
	int			 i;
	XmString	 str;
	XmString	 accm;
	Arg			 args[8];
	int			 n;

	PullDown = XmCreatePulldownMenu (parent, "_pulldown", NULL, 0);

	if (tear_off) 
		XtVaSetValues (PullDown, XmNtearOffModel, XmTEAR_OFF_ENABLED, NULL);

	str = XmStringCreateLocalized (menu_title);

	n   = 0;
	XtSetArg (args[n], XmNsubMenuId, PullDown); 	n++;
	XtSetArg (args[n], XmNlabelString, str); 		n++;
	if  (menu_mnemonic) {
		XtSetArg (args[n], XmNmnemonic, menu_mnemonic); n++;
	}
	cascade = XmCreateCascadeButtonGadget (parent, menu_title, args, n);

	XtManageChild (cascade);

	XmStringFree (str);

	for (i = 0; items[i].label != NULL; i++) {
		if (items[i].subitems)
			widget = BuildPulldownMenu (PullDown,
												items[i].label,
												items[i].mnemonic,
												tear_off,
												items[i].subitems);
		else
			widget = XtVaCreateManagedWidget (items[i].label,
											   *items[i].class,
												PullDown,
												NULL);

		if (items[i].mnemonic)
			XtVaSetValues (widget, XmNmnemonic, items[i].mnemonic, NULL);

		if (items[i].accelerator) {
			str = XmStringCreateLocalized (items[i].accel_text);
			XtVaSetValues (widget, XmNaccelerator, items[i].accelerator, 
										XmNacceleratorText, str, NULL);
			XmStringFree (str);
		}

		if (items[i].callback) {
			String 		resource;

			if (XmIsToggleButton (widget) || (XmIsToggleButtonGadget (widget)))
				resource = XmNvalueChangedCallback;
			else
				resource = XmNactivateCallback;
 
			XtAddCallback (widget, resource, items[i].callback,
							(XtPointer) items[i].callback_data);
		}
	}

	return cascade;
}

void UnmapWindow( )
{
	XtUnmapWidget(main_w);
}

void MapWindow( )
{
	XtMapWidget(main_w);
}

void CreateWindow( )
{
	Arg			   	args[4];
	int			   	n;

	n = 0;
	XtSetArg (args[n], XmNscrollingPolicy, XmAUTOMATIC); n++;
	main_w 	= XmCreateMainWindow (toplevel, "main_w", args, n);

	menubar = XmCreateMenuBar (main_w, "menubar", NULL, 0);

	BuildPulldownMenu (menubar, "Lines"  , 'L', True, line_menus   );
	BuildPulldownMenu (menubar, "Circle" , 'C', True, circle_menus );
	BuildPulldownMenu (menubar, "Angle"  , 'A', True, angle_menus  );
	BuildPulldownMenu (menubar, "Restart", 'R', True, restart_menus);
	BuildPulldownMenu (menubar, "Exit"   , 'E', True, exit_menus   );

	XtManageChild (menubar);

	n = 0;
	XtSetArg (args[n], XmNwidth , 600);	n++;
	XtSetArg (args[n], XmNheight, 200); n++;
	drawing_a = XmCreateDrawingArea (main_w, "drawing_a", args, n);

	XFlush(XtDisplay(toplevel));
}

main (int argc, char *argv[])
{
//	XEvent 			event;

	XtSetLanguageProc (NULL, NULL, NULL);
	toplevel = XtVaOpenApplication (&app, "Demos", NULL, 0, &argc, argv, NULL, 
									sessionShellWidgetClass, NULL);

	CreateWindow( );
	
	XtManageChild (drawing_a);

	XtManageChild (main_w);

	XtRealizeWidget (toplevel);

	XtAppMainLoop (app);
//	while(1) {
//		XtAppNextEvent(app,&event);
//		XtDispatchEvent(&event);
//	}
}
